/* motor2.c */
/* MOTOR^XN͒/x̒Pʂ[cm][cm/s]Ő䂵܂ */
/* Scilab[m][m/s]Ő䂵܂(toppers֓͂̍ۂ[m]->[cm]ϊ܂)*/

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "kernel_cfg.h"
#include "itron.h"
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "rtos_api.h"
#include "motor2.h"


/*----^XNŗLϐ`---*/
static long_t gMotor2_Position;
static long_t gMotor2_TargetPosition;
static long_t gMotor2_TargetSpeed;
static long_t gMotor2_Direction;

/* PID֘A */
static long_t gdelta_speed_Sum;
static long_t gPredelta_speed;
static long_t gdelta_position_Sum;
static long_t gPredelta_position;

/*HALwAhX`*/

/* COMIuWFNgp AhX`(SkyEye̒`ƍ킹) */
/* [^[1p AhXItZbg */
#define MOTOR_INT_ENABLE	(0)		/* int */
#define MOTOR2_SPEED		(0x8000101C)	/* int */		
#define MOTOR2_POSITION		(0x80001020)	/* int */
#define MOTOR2_PWMDUTY		(0x8000100C)	/* int */
#define MOTOR2_PWMPERIOD	(0x80001010)	/* int */
#define MOTOR2_INT_ENABLE	(0x80001028)	/* int */


/*------------֐̒`----------*/
/*^XNw*/
void init_MOTOR2(void);
void start_MOTOR2(long_t Speed, long_t Length, long_t Event);
/*ݑw*/
void Int_PIDControl4MOTOR2(void);
void SetMotor2IntEnable(void);
void ResetMotor2IntEnable(void);
bool_t GetMotor2IntEnable(void);
bool_t* Motor2IntEnable(void);

/*CxgtOZbgp*/
void (*evtflgfunc2)(void);
void reset_motor2_event(void);
/*^XNNp*/
void (*wakeupfunc2)(void);
void reset_motor2_sleep(void);
void nullfunc2(void);

/*HALw*/
long_t HAL_GetMotor2Speed(void);
long_t HAL_GetMotor2Position(void);
void HAL_SetMotor2Speed(long_t speed);
void HAL_SetMotor2Position(long_t position);
void HAL_SetMotor2PWMDuty(long_t Duty);
void HAL_SetMotor2PWMPeriod(long_t Period);

/*----------MotorAPIw-------------*/

void Motor2_Init(void)
{
	MOTOR2_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR2, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR2_INIT;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR2, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pSndMsg);
	} 
}

void Motor2_DRV(long_t Speed, long_t Length)
{
	MOTOR2_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR2, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR2_DRV;
	pSndMsg->Speed					=  Speed;
	pSndMsg->Length					=  Length;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR2, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
		ercd = tprs_receivemail( (ID)MB_MOTOR2_RCV, (T_MSG **)&pSndMsg);
		if(ercd == E_OK){
			if(pSndMsg->result == TRUE){
				syslog(LOG_INFO, "Motor2_DRV_Req_OK");
			}
			else{
				syslog(LOG_INFO, "Motor2_DRV_Req_NG");	
			}
		}
		else{
			syslog(LOG_INFO, "> tprs_receivemail_MOTOR2_RCV_NG");	
		}
		
		(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pSndMsg);
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pSndMsg);
	} 
}

void Motor2_DRVEvent(long_t Speed, long_t Length)
{
	MOTOR2_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR2, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR2_DRV_EVENT;
	pSndMsg->Speed					=  Speed;
	pSndMsg->Length					=  Length;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR2, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
		ercd = tprs_receivemail( (ID)MB_MOTOR2_RCV, (T_MSG **)&pSndMsg);
		if(ercd == E_OK){
			if(pSndMsg->result == TRUE){
				syslog(LOG_INFO, "Motor2_DRV_Req_OK");
			}
			else{
				syslog(LOG_INFO, "Motor2_DRV_Req_NG");	
			}
		}
		else{
			syslog(LOG_INFO, "> tprs_receivemail_MOTOR2_RCV_NG");	
		}
		
		(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pSndMsg);
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pSndMsg);
	} 
}


void Motor2_Stop(void)
{
	MOTOR2_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR2, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR2_STOP;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR2, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pSndMsg);
	} 
}

void Motor2_Wait_DRVStop(void)
{
	FLGPTN waitflag;
	tprs_waiteventflag( EV_MOTOR2, event_MOTOR2DRV, TWF_ANDW, &waitflag );

}

/* VN쓮p */
void Motor2_Wait_EventStop(void)
{
	FLGPTN waitflag;
	tprs_waiteventflag( EV_MOTOR2, event_MOTOR2DRV_PRESTART, TWF_ANDW, &waitflag );

}

/*--------taskMain-------------*/
void Motor2(intptr_t exinf)
{
	ER ercd;
	MOTOR2_RQST_MSG_ST *pMsg;

	init_MOTOR2();
	
	while (1) {
		ercd = tprs_receivemail( (ID)MB_MOTOR2, (T_MSG **)&pMsg);
		if (ercd == E_OK) {
			switch (pMsg->func_code) {
			
			case MOTOR2_INIT:
				init_MOTOR2();
				(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pMsg);
				break;

			case MOTOR2_DRV:
				start_MOTOR2(pMsg->Speed, pMsg->Length, MOTOR2_NO_EVENT);
				pMsg->result = TRUE;
				ercd = tprs_sendmail((ID)MB_MOTOR2_RCV, (T_MSG *)pMsg);
				break;
				
			case MOTOR2_DRV_EVENT:
				start_MOTOR2(pMsg->Speed, pMsg->Length, MOTOR2_PRESTART);
				pMsg->result = TRUE;
				ercd = tprs_sendmail((ID)MB_MOTOR2_RCV, (T_MSG *)pMsg);
				break;
				
			case MOTOR2_STOP:
				ResetMotor2IntEnable();
				(void)tprs_releasememoryblock((ID)POOL_MOTOR2, (VP)pMsg);
			default:			
				break;								
			}
		}
	}	/*while*/
}


/*--------------^XNAPIw------------*/
void init_MOTOR2(void)
{
	gMotor2_Position = 0;
	gMotor2_TargetPosition = 0;
	gMotor2_TargetSpeed = MOTOR2_SPEEDLOW;
	gMotor2_Direction = 1;
	gdelta_speed_Sum = 0;
	gPredelta_speed = 0;
	gdelta_position_Sum = 0;
	gPredelta_position = 0;
	
	wakeupfunc2 = nullfunc2;
	evtflgfunc2 = nullfunc2;

	tprs_seteventflag( EV_MOTOR2, event_MOTOR2DRV );
	tprs_seteventflag( EV_MOTOR2, event_MOTOR2DRV_PRESTART );
	
	ResetMotor2IntEnable();
	HAL_SetMotor2PWMDuty(0);
	HAL_SetMotor2PWMPeriod( PID2_MAX);
	HAL_SetMotor2Speed(0);
	HAL_SetMotor2Position(0);
	syslog(LOG_NOTICE, "MOTOR2_InitFin \n");
}


void start_MOTOR2(long_t Speed, long_t Length, long_t Event)
{

	ResetMotor2IntEnable();
	/*ڕWxݒ*/
	gMotor2_TargetSpeed = Speed;
	/*싗̕ϊ*/
	gMotor2_TargetPosition = gMotor2_Position + Length;
	/*PID֘Ȁ*/
	gdelta_speed_Sum = 0;
	gPredelta_speed = 0;
	gdelta_position_Sum = 0;
	gPredelta_position = 0;
	/*̐ݒ*/
	if(Length < 0){
		gMotor2_Direction = 0;
	}
	else{
		gMotor2_Direction = 1;
	}

	/*Jn*/
	if(Event == MOTOR2_PRESTART){
		evtflgfunc2 = reset_motor2_event;
	}
	else{
		evtflgfunc2 = nullfunc2;
	}
	
	tprs_cleareventflag( EV_MOTOR2 , ~event_MOTOR2DRV );
	tprs_cleareventflag( EV_MOTOR2 , ~event_MOTOR2DRV_PRESTART );
			
//	HAL_SetMotor2PWMPeriod( PID2_MAX);

	SetMotor2IntEnable();
	
//	intenable = TRUE;
//	while(intenable == TRUE){
//		tprs_delaytask(50);
////		intenable = intenable = GetMotor2IntEnable();
//	}

	syslog(LOG_INFO, "Motor2_DRV_Start");

}


void reset_motor2_event(void)
{
//	tprs_intwakeuptask(MOTOR2);
	tprs_intseteventflag( EV_MOTOR2, event_MOTOR2DRV_PRESTART );
	evtflgfunc2 = nullfunc2;
}

void reset_motor2_sleep(void)
{
	tprs_intwakeuptask(MOTOR2);
	wakeupfunc2 = nullfunc2;
}

void nullfunc2(void)
{

}


void SetMotor2IntEnable(void)
{
	bool_t* pint_enable_flag = Motor2IntEnable();
	*pint_enable_flag = TRUE;
}

void ResetMotor2IntEnable(void)
{
	bool_t* pint_enable_flag = Motor2IntEnable();
	*pint_enable_flag = FALSE;
}

bool_t GetMotor2IntEnable(void)
{
	bool_t* pint_enable_flag = Motor2IntEnable();
	return (*pint_enable_flag);
}

bool_t* Motor2IntEnable(void)
{
	static bool_t sMotor2IntEnbFlag = FALSE;
	return &sMotor2IntEnbFlag;
}


/*------ݐw-------------*/
void Int_Motor2(void)
{
	bool_t int_motor2_enable = GetMotor2IntEnable();
	
	if(int_motor2_enable == TRUE){
		Int_PIDControl4MOTOR2();
	}
	else{
		/* 䖳̂߉Ȃ */
		HAL_SetMotor2PWMDuty(0);
	}

}

void Int_PIDControl4MOTOR2(void)
{
	long_t speed;
	long_t position;
	long_t delta_speed;
	long_t delta_position;

	long_t Duty_P;
	long_t Duty_I;
	long_t Duty_D;
	long_t Duty_PID;

	static long_t sHoldCnt;

	speed = HAL_GetMotor2Speed();
	position = HAL_GetMotor2Position();

	/*݈ʒu̍XV*/
	gMotor2_Position = position;

	/*ʒu΍̌v*/
	if(gMotor2_Direction == 1){
		delta_position = gMotor2_TargetPosition - position;
	}
	else{
		delta_position = position - gMotor2_TargetPosition;
	}
	
	if(delta_position <= 5){
		gMotor2_TargetSpeed = MOTOR2_SPEEDLOW;
	}
	else if(delta_position <= 10){
		gMotor2_TargetSpeed = MOTOR2_SPEEDMID;
		sHoldCnt = 0;
		evtflgfunc2();	/* OJnpCxg̐ݒ */
	}
	else{
		/*ڕWx̂܂*/
	}

	if(delta_position <= 0){
		/*ʒuߐ*/
		if(sHoldCnt > 10){
			ResetMotor2IntEnable();
			tprs_intseteventflag( EV_MOTOR2, event_MOTOR2DRV );
			tprs_intseteventflag( EV_MOTOR2, event_MOTOR2DRV_PRESTART );
			sHoldCnt = 0;
			Duty_PID = 0;
		}
		else{
			/*P̌vZ*/
			Duty_P = GAIN2_P * delta_position;
			/*ǏvZ*/
			gdelta_position_Sum = gdelta_position_Sum + delta_position;
			Duty_I = GAIN2_I * gdelta_position_Sum;
			/*ĎvZ*/
			Duty_D = GAIN2_D * (delta_position - gPredelta_position);
			gPredelta_position = delta_position;

			Duty_PID = Duty_P + Duty_I + Duty_D;
		}
		sHoldCnt++;
	}
	else{
		/* x */
		/*x΍̌v*/
		delta_speed = gMotor2_TargetSpeed - speed;
	
		/*P̌vZ*/
		Duty_P = GAIN2_P * delta_speed;
		/*ǏvZ*/
		gdelta_speed_Sum = gdelta_speed_Sum + delta_speed;
		Duty_I = GAIN2_I * gdelta_speed_Sum;
		/*ĎvZ*/
		Duty_D = GAIN2_D * (delta_speed - gPredelta_speed);
		gPredelta_speed = delta_speed;

		Duty_PID = Duty_P + Duty_I + Duty_D;
	}


	/*PIDo͐*/
	if(PID2_MAX < Duty_PID){
		Duty_PID = PID2_MAX;
	}
	else if(PID2_MIN > Duty_PID){
		Duty_PID = PID2_MIN;
	}
	else{
		/*Ȃ*/
	}


	/*PWMo*/
	HAL_SetMotor2PWMDuty(Duty_PID);

}


/*---HALw̒`------*/
long_t HAL_GetMotor2Speed(void)
{
	long_t* pMotor2Speed = (long_t*)MOTOR2_SPEED;
	return (*pMotor2Speed);
}

void HAL_SetMotor2Speed(long_t speed)
{
	long_t* pMotor2Speed = (long_t*)MOTOR2_SPEED;
	*pMotor2Speed = speed;
}

long_t HAL_GetMotor2Position(void)
{
	long_t* pMotor2Position = (long_t*)MOTOR2_POSITION;
	return (*pMotor2Position);
}

void HAL_SetMotor2Position(long_t position)
{
	long_t* pMotor2Position = (long_t*)MOTOR2_POSITION;
	*pMotor2Position = position;
}

void HAL_SetMotor2PWMDuty(long_t Duty)
{
	long_t* pMotor2PWMDuty = (long_t*)MOTOR2_PWMDUTY;
	*pMotor2PWMDuty = Duty;
}

void HAL_SetMotor2PWMPeriod(long_t Period)
{
	long_t* pMotor2PWMPeriod = (long_t*)MOTOR2_PWMPERIOD;
	*pMotor2PWMPeriod = Period;
}

